signature LISTUTILS = sig

(* Miscellaneous utilities for manipulating lists *)

val memq: ('a -> 'a -> bool) -> 'a list -> 'a -> bool
exception Assoc
val assoc: ('a -> 'a -> bool) -> ('a * 'b) list -> 'a -> 'b

val mapappend: ('a -> 'b list) -> ('a list) -> ('b list)
val mapappend_tuple: ('a -> 'b list) -> 'b -> ('a list) -> ('b list)
val mapunit: ('a -> 'b) -> ('a list) -> unit
val mapunit_tuple: ('a -> unit) -> (unit -> unit) -> ('a list) -> unit

val mapfold: ('a -> 'b) -> ('b -> 'b -> 'b) -> 'b -> ('a list) -> 'b
val forall: ('a -> bool) -> ('a list) -> bool
val forallpairs: (('a * 'b) -> bool) -> ('a list) -> ('b list) -> bool
val forsome: ('a -> bool) -> ('a list) -> bool

val filter: ('a -> bool) -> ('a list) -> ('a list)

val zip: ('a list) -> ('b list) -> (('a * 'b) list)

end


