functor StringUtils() : STRINGUTILS = struct

exception NotABoolean

fun string_to_bool "true" = true
  | string_to_bool "True" = true
  | string_to_bool "TRUE" = true
  | string_to_bool "t" = true
  | string_to_bool "T" = true
  | string_to_bool "yes" = true
  | string_to_bool "Yes" = true
  | string_to_bool "YES" = true
  | string_to_bool "false" = false
  | string_to_bool "False" = false
  | string_to_bool "FALSE" = false
  | string_to_bool "f" = false
  | string_to_bool "F" = false
  | string_to_bool "no" = false
  | string_to_bool "No" = false
  | string_to_bool "NO" = false
  | string_to_bool _ = raise NotABoolean

fun is_int s = let
  fun f (d::rest) = ((ord d) >= (ord "0") andalso (ord d) <= (ord "9"))
                    orelse (d = "-")
    | f []        = true
  in f (explode s)
  end

fun stringtoint s = let
  fun f [] = 0
    | f (d::ds) = (f ds) * 10 + (ord d) - (ord "0")
  fun body s = f (rev s)
  fun neg ("-"::rest) = 0 - (body rest)
    | neg b = body b
  in neg (explode s)
  end

fun prefix line len = substring(line,0,min(len,size line))    

fun suffix line before_len = substring(line,before_len,(size line)-before_len)

(* $$$ Pretty damn inefficient: *)
fun replace_string from to line = let 
  fun r line =
      if size(line) < size(from) 
	then line
      else if prefix line (size from) = from
	then to ^ (r (suffix line (size from)))
      else (prefix line 1) ^ (r (suffix line 1))
  in r line
  end

end
