signature MY_TOKENS =
sig
type ('a,'b) token
type svalue
val T_FAIL:  'a * 'a -> (svalue,'a) token
val T_STOP:  'a * 'a -> (svalue,'a) token
val T_WIDTH:  'a * 'a -> (svalue,'a) token
val T_HIDING:  'a * 'a -> (svalue,'a) token
val T_AS:  'a * 'a -> (svalue,'a) token
val T_BEGIN:  'a * 'a -> (svalue,'a) token
val T_PACK:  'a * 'a -> (svalue,'a) token
val T_END:  'a * 'a -> (svalue,'a) token
val T_OPEN:  'a * 'a -> (svalue,'a) token
val T_SOME:  'a * 'a -> (svalue,'a) token
val T_INSTALL:  'a * 'a -> (svalue,'a) token
val T_OBSERVE:  'a * 'a -> (svalue,'a) token
val T_FOR:  'a * 'a -> (svalue,'a) token
val T_OF:  'a * 'a -> (svalue,'a) token
val T_BCASE:  'a * 'a -> (svalue,'a) token
val T_CASE:  'a * 'a -> (svalue,'a) token
val T_NS:  'a * 'a -> (svalue,'a) token
val T_IN:  'a * 'a -> (svalue,'a) token
val T_ALL:  'a * 'a -> (svalue,'a) token
val T_WITH:  'a * 'a -> (svalue,'a) token
val T_CHECK:  'a * 'a -> (svalue,'a) token
val T_DEBUG:  'a * 'a -> (svalue,'a) token
val T_RESET:  'a * 'a -> (svalue,'a) token
val T_SET:  'a * 'a -> (svalue,'a) token
val T_TYPE:  'a * 'a -> (svalue,'a) token
val T_USE:  'a * 'a -> (svalue,'a) token
val T_STR_CONST: (string) *  'a * 'a -> (svalue,'a) token
val T_INT_CONST: (string) *  'a * 'a -> (svalue,'a) token
val T_ID: (string) *  'a * 'a -> (svalue,'a) token
val T_BIGLAMBDA:  'a * 'a -> (svalue,'a) token
val T_LAMBDA:  'a * 'a -> (svalue,'a) token
val T_INTER:  'a * 'a -> (svalue,'a) token
val T_RCURLY:  'a * 'a -> (svalue,'a) token
val T_LCURLY:  'a * 'a -> (svalue,'a) token
val T_RANGLE:  'a * 'a -> (svalue,'a) token
val T_LANGLE:  'a * 'a -> (svalue,'a) token
val T_RBRACK:  'a * 'a -> (svalue,'a) token
val T_LBRACK:  'a * 'a -> (svalue,'a) token
val T_RPAREN:  'a * 'a -> (svalue,'a) token
val T_LPAREN:  'a * 'a -> (svalue,'a) token
val T_PLUSGREATER:  'a * 'a -> (svalue,'a) token
val T_LESSPLUS:  'a * 'a -> (svalue,'a) token
val T_PLUSPLUS:  'a * 'a -> (svalue,'a) token
val T_VBAR:  'a * 'a -> (svalue,'a) token
val T_PLUS:  'a * 'a -> (svalue,'a) token
val T_BANG:  'a * 'a -> (svalue,'a) token
val T_MINUSMINUS:  'a * 'a -> (svalue,'a) token
val T_STARSTAR:  'a * 'a -> (svalue,'a) token
val T_COLONEQ:  'a * 'a -> (svalue,'a) token
val T_COLONCOLON:  'a * 'a -> (svalue,'a) token
val T_SEMISEMI:  'a * 'a -> (svalue,'a) token
val T_QUESTION:  'a * 'a -> (svalue,'a) token
val T_DARROW:  'a * 'a -> (svalue,'a) token
val T_ARROW:  'a * 'a -> (svalue,'a) token
val T_AT:  'a * 'a -> (svalue,'a) token
val T_DOLLAR:  'a * 'a -> (svalue,'a) token
val T_DOUBLEEQ:  'a * 'a -> (svalue,'a) token
val T_EQ:  'a * 'a -> (svalue,'a) token
val T_MINUS:  'a * 'a -> (svalue,'a) token
val T_STAR:  'a * 'a -> (svalue,'a) token
val T_APOST:  'a * 'a -> (svalue,'a) token
val T_COMMA:  'a * 'a -> (svalue,'a) token
val T_LEQ:  'a * 'a -> (svalue,'a) token
val T_SEMICOLON:  'a * 'a -> (svalue,'a) token
val T_COLON:  'a * 'a -> (svalue,'a) token
val T_DOT:  'a * 'a -> (svalue,'a) token
val T_EOF:  'a * 'a -> (svalue,'a) token
end
signature MY_LRVALS=
sig
structure Tokens : MY_TOKENS
structure ParserData:PARSER_DATA
sharing type ParserData.Token.token = Tokens.token
sharing type ParserData.svalue = Tokens.svalue
end
