signature TRM = sig

structure Globals: GLOBALS
structure Typ: TYP
structure TEnv: TENV
structure TypHelper: TYPHELPER
sharing Typ.Globals = Globals
    and TypHelper.Typ = Typ
    and TypHelper.TEnv = TEnv
include GLOBALS
sharing Id = Globals.Id

datatype T = 
	    VAR of int
	  | ABS of Id.T * Typ.T * T
	  | APP of T * T
	  | TABS of Id.T * Typ.T * T
	  | TAPP of T * Typ.T
          | RCDV of (Id.T * T) list
	  | PROJ of T * Id.T 
	  | OPEN of Id.T * Id.T * T * T
	  | PACK of T * Typ.T * Typ.T 
	  | ASSERT of T * Typ.T
	  | ABBREV of Id.T * Typ.T * T
	  | LET of Id.T * T * T
	  | PRIM of string * Typ.T

val relocate: int -> T -> T

val subst_top: 
	(* substitute... *)			T 
	(* for instances of #0 in... *)	     -> T 
			     		     -> T
val subst_top_type: 
	(* substitute... *)			Typ.T
	(* for instances of #0 in... *)	     -> T 
			     		     -> T
val prt_exactly: T -> unit
val prt_primitive: string -> unit

end

